﻿/*-------------------------------------------------------------------------
 Cryptographic module interface for block ciphers.
 
 File name   : CipherModule/IBlockCipher.cs
 Version     : Version 1.2
 Created     : Aug/20/2008
 Last update : Jun/27/2011
 Desgined by : Toshihiro Katashita
 
 
 Copyright (C) 2008 - 2011 AIST
 
 By using this code, you agree to the following terms and conditions.
 
 This code is copyrighted by AIST ("us").
 
 Permission is hereby granted to copy, reproduce, redistribute or
 otherwise use this code as long as: there is no monetary profit gained
 specifically from the use or reproduction of this code, it is not sold,
 rented, traded or otherwise marketed, and this copyright notice is
 included prominently in any copy made.
 
 We shall not be liable for any damages, including without limitation
 direct, indirect, incidental, special or consequential damages arising
 from the use of this code.
 
 When you publish any results arising from the use of this code, we will
 appreciate it if you can cite our webpage
 (http://staff.aist.go.jp/akashi.satoh/SASEBO/en/).
 -------------------------------------------------------------------------*/

using System;
using System.Collections.Generic;
using System.Text;

namespace CipherModule{
  //================================================================ CipherInterface
  public interface IBlockCipher
  {
    void setKey(byte[] key, int len);
    void setEnc();
    void setDec();
    void writeText(byte[] text, int len);
    void readText (byte[] text, int len);
    void execute();
//  void reset();
    void select (int type);
  }
}
